#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3200six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 3200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six32004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six32004xi = {
                1:'-1002x1878y-2389z', 
                2:'-1086x1802y-2410z',
                3:'-1102x2827y-1015z',
                4:'-1144x2828y-962z',
                5:'-1166x1723y-2431z',
                6:'-1240x1640y-2451z',
                7:'-1244x2756y-1045z',
                8:'-1287x2756y-993z',
                9:'-1308x1554y-2472z',
                10:'-1370x1465y-2492z',
                11:'-1382x2678y-1075z',
                12:'-1424x2676y-1023z',
                13:'-1427x1374y-2512z',
                14:'-1478x1281y-2532z',
                15:'-1515x2592y-1105z',
                16:'-1523x1186y-2551z',
                17:'-1557x2589y-1053z',
                18:'-1562x1090y-2570z',
                19:'-1595x993y-2589z',
                20:'-159x1259y-2937z',
                21:'-1611x53y-2764z',
                22:'-1622x896y-2608z',
                23:'-1633x140y-2748z',
                24:'-1642x2500y-1135z',
                25:'-1643x798y-2626z',
                26:'-1651x229y-2731z',
                27:'-1659x701y-2644z',
                28:'-1663x320y-2714z',
                29:'-1668x604y-2662z',
                30:'-1670x413y-2697z',
                31:'-1672x508y-2680z',
                32:'-1684x2495y-1083z',
                33:'-1764x2401y-1165z',
                34:'-1806x2394y-1113z',
                35:'-1880x2297y-1195z',
                36:'-1922x2288y-1143z',
                37:'-1989x2186y-1224z',
                38:'-2019x2482y-9z',
                39:'-2031x2176y-1173z',
                40:'-2092x2070y-1254z',
                41:'-2134x2058y-1203z',
                42:'-2146x2373y-41z',
                43:'-2188x1949y-1283z',
                44:'-220x1220y-2949z',
                45:'-2229x1936y-1232z',
                46:'-2267x2257y-73z',
                47:'-2277x1824y-1313z',
                48:'-2318x1809y-1262z',
                49:'-2359x1695y-1342z',
                50:'-2381x2134y-105z',
                51:'-2399x1677y-1291z',
                52:'-2433x1562y-1371z',
                53:'-2472x1543y-1320z',
                54:'-2489x2006y-137z',
                55:'-2499x1425y-1399z',
                56:'-2538x1405y-1350z',
                57:'-2558x1286y-1428z',
                58:'-2589x1872y-169z',
                59:'-2608x1145y-1457z',
                60:'-2651x1001y-1485z',
                61:'-2677x1303y-1422z',
                62:'-2682x1733y-201z',
                63:'-2685x857y-1513z',
                64:'-2712x711y-1542z',
                65:'-2730x565y-1569z',
                66:'-2737x129y-1652z',
                67:'-2740x419y-1597z',
                68:'-2742x273y-1625z',
                69:'-2767x1589y-233z',
                70:'-277x1178y-2962z',
                71:'-282x2273y-2234z',
                72:'-2844x1441y-264z',
                73:'-2913x1289y-296z',
                74:'-2974x1134y-328z',
                75:'-3026x975y-360z',
                76:'-3069x815y-392z',
                77:'-3103x652y-424z',
                78:'-3129x488y-455z',
                79:'-3146x323y-487z',
                80:'-3153x158y-518z',
                81:'-330x1133y-2974z',
                82:'-338x3063y-862z',
                83:'-379x1086y-2985z',
                84:'-397x2233y-2257z',
                85:'-424x1037y-2997z',
                86:'-439x13y-3169z',
                87:'-465x987y-3008z',
                88:'-470x39y-3165z',
                89:'-496x3032y-892z',
                90:'-498x68y-3160z',
                91:'-501x934y-3018z',
                92:'-508x2187y-2279z',
                93:'-525x99y-3154z',
                94:'-534x881y-3029z',
                95:'-537x3040y-839z',
                96:'-550x134y-3149z',
                97:'-562x827y-3039z',
                98:'-572x172y-3143z',
                99:'-586x772y-3049z',
                100:'-592x212y-3137z',
                101:'-606x717y-3058z',
                102:'-609x255y-3131z',
                103:'-615x2135y-2301z',
                104:'-622x662y-3068z',
                105:'-623x300y-3124z',
                106:'-634x348y-3117z',
                107:'-634x607y-3077z',
                108:'-641x397y-3109z',
                109:'-641x553y-3085z',
                110:'-645x447y-3102z',
                111:'-645x500y-3094z',
                112:'-652x2993y-923z',
                113:'-694x3000y-870z',
                114:'-719x2078y-2324z',
                115:'-805x2946y-954z',
                116:'-818x2016y-2345z',
                117:'-847x2951y-901z',
                118:'-912x1949y-2367z',
                119:'-956x2890y-984z',
                120:'-95x1295y-2924z',
                121:'-998x2893y-932z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3200six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire3200six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3200SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3200SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3200SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3200SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3200SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six32004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3200SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3200SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3200SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six3200x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six3200x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3200SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE3200SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3200SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3200six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
